%******************************************************************
%MATINI....2
% TVORBA ADMITANCNI MATICE A INICIACE VEKTORU

%	vetev s obecnym prenosem
Ykm=1 ./(R+i*X);		%
Ykk=(T-1)./T.*Ykm;
Ymm=(1.-T) ./T.^2 .*Ykm;
Ykm=Ykm ./T;
Svod=i*B ./2;				% susceptance je u PI clanku polovicni

%	Vytvoreni ridke matice site
Y=sparse(NU,NU);
for I = 1:NV			% pro vsechny  vetve
  Y(ZU(I),ZU(I))=Y(ZU(I),ZU(I))+Ykm(I)+Ykk(I)+Svod(I);
  Y(KU(I),KU(I))=Y(KU(I),KU(I))+Ykm(I)+Ymm(I)+Svod(I);
  Y(ZU(I),KU(I))=Y(ZU(I),KU(I))-Ykm(I);
  Y(KU(I),ZU(I))=Y(KU(I),ZU(I))-Ykm(I);
end

%Vytvoreni pomocnych vektoru
[II,JJ,Yij]=find(Y);		    % do Yij vyber vsechny nenulove prvky
Ym=abs(Yij);
Gama=angle(Yij);   % admitann hel prvk  Y matice

PQPU=TU~=3;           	% PQ a PU uzly bez slack
IndPQPU=find(PQPU);     % indexy PQ a PU
PQ=TU==1;             	% uzly PQ
PU=TU==2;          		% uzly PU
IndPQ=find(PQ);    		%  indexy uzlu PQ
IndPU=find(PU);	   		%  indexy uzlu PU
Slack=TU==3;
IndSlack=find(Slack);

%nastaveni napeti
Um=ones(NU,1);            % pocatecni odhad napeti
UhelUzlu=zeros(NU,1);     % pocatecni odhad uhlu
Um(IndPU)=UW(IndPU);     % nastav kontrolovane napeti PU
Um(IndSlack)=UW(IndSlack);% nastav kontrolovane napeti Slack
%deklarace vektoru
UhelVetve=zeros(size(II,1),1);%vektor pro rozdily uhlu na obou koncu vetvi
UUy=zeros(size(II,1),1);	% nulovani vektoru souinu napt a vodivosti
PomSpr=1:size(II,1); % pomocny vektor ridke matice
KorUhel=zeros(NU,1);
KorUm=zeros(NU,1);
IndUhel=1:size(IndPQPU,1);
IndUm=1:size(IndPQ,1);
%**********************************************************************